unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IdBaseComponent, IdComponent, IdUDPBase,
  IdUDPClient,inifiles,XpMan;

type
  TForm1 = class(TForm)
    UDPClientSimulador: TIdUDPClient;
    UDPClientMontador: TIdUDPClient;
    Button1: TButton;
    Memo1: TMemo;
    TimerCarros: TTimer;
    EditCarros: TEdit;
    EditVueltas: TEdit;
    EditViajes: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    TimerVuelta: TTimer;
    Label4: TLabel;
    Label5: TLabel;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimerCarrosTimer(Sender: TObject);
    procedure TimerVueltaTimer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var num_viaje,num_vuelta,num_carro: integer;

procedure TForm1.FormCreate(Sender: TObject);
begin
     num_viaje:=0;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
i:TIniFile;

begin

     if Button1.Caption = 'Start' then
     begin
          Button1.Caption:= 'Stop';
          num_vuelta:= 1;
          num_carro:= 1;
          i:=TIniFile.Create('C:\Users\Paco\Desktop\@BIBLIOTECA DELPHI\Ejemplos Delphi\20091118_Sensor\Sensor\configuracion.ini');
          TimerCarros.Interval:=strtoint(i.ReadString('TIMESENSOR','timecarro',''));
          TimerVuelta.Interval:=strtoint(i.ReadString('TIMESENSOR','timevuelta',''));
          Memo1.Lines.Add('--------- Inicio vuelta '+IntToStr(num_vuelta)+' ------');
          TimerCarros.Enabled:= true;
     end
     else
     begin
          Button1.Caption:= 'Start';
          TimerCarros.Enabled:= false;
          TimerVuelta.Enabled:= false;
     end;
end;//Del botn -START-



procedure TForm1.TimerCarrosTimer(Sender: TObject);
begin
     Form1.UDPClientSimulador.Send('click');
     
     Form1.UDPClientMontador.Send('click');
     Memo1.Lines.Add('Carro: '+IntToStr(num_carro));
     Inc(num_carro);
     if num_carro > StrToInt(EditCarros.Text) then
     begin
          TimerCarros.Enabled:= false;
          TimerVuelta.Enabled:= true;
          Memo1.Lines.Add('----------------- Fin vuelta '+IntToStr(num_vuelta)+' -------');
          Memo1.Lines.Add('');
     end;
end;

procedure TForm1.TimerVueltaTimer(Sender: TObject);
begin
     TimerVuelta.Enabled:= false;
     Inc(num_vuelta);

     if num_vuelta > StrToInt(EditVueltas.Text) then
     begin
          Form1.Button1.Caption:= 'Start';
          num_vuelta:= 1;
          Inc(num_viaje);
          EditViajes.Text:= IntToStr(num_viaje);
          Memo1.Lines.Add('');
          Memo1.Lines.Add('********** Fin de viaje '+IntToStr(num_viaje)+' ******');
          Memo1.Lines.Add('');
     end
     else
     begin
           num_carro:=1;
           Memo1.Lines.Add('--------- Inicio vuelta '+IntToStr(num_vuelta)+' ------');
           TimerCarros.Enabled:= true;
     end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin

Form1.Close;

end;

end.
