unit U_Montador;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdUDPServer, IdBaseComponent, IdComponent, IdUDPBase,
  IdUDPClient, IdSocketHandle, ExtCtrls,ShellAPI,XpMan;



type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Button1: TButton;
    IdUDPServer1: TIdUDPServer;
    Button2: TButton;
    Timer1: TTimer;
    Timer2: TTimer;
    Timer3: TTimer;
    IdUDPClientShowrun: TIdUDPClient;
    procedure IdUDPServer1UDPRead(Sender: TObject; AData: TStream;
      ABinding: TIdSocketHandle);
    procedure Button2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    function TestDirectorio():string;
    procedure TestInicial();
    procedure ProcesoRutina();
    procedure GestionFoto();
    procedure MoverFotos();
    procedure Redimensionar(Imagen: TGraphic; Ancho, Alto: Integer);
    procedure CopiarFotos();
    

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
 

  viaje:boolean;//ESTAMOS EN UN VIAJE?.//TESTINICIAL();
  FinViaje:boolean;//A TERMINADO UN VIJAE?
  PARAMETROS:boolean;


  vuelta:integer;//NUMERO DE VUELTAS X VIAJE.//Timer2//Timer3
  carros:integer;//NUMERO DE CARROS.

  CarroActual:integer;
  VueltaActual:integer;
  ViajeActual:integer;
  m:integer;
  l:integer;

  TotCarros: real;//NUMERO TOTAL DE CARROS
  TotVueltas: integer;//NUMERO TOTAL DE VUELTAS:
  Total: integer;// TOTAL DE CARROS EN UN VIAJE

  ruta:string;//Directorio del dia actual.
  miniruta:string;//Directorio del dia actual donde se copian la fotos en miniatura del dia actual.
  recibido:string;//Seal recibida por parte del sensor


implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);//BOTON START
          //var


          begin

               PARAMETROS:=false;

               ruta:='NO RUTA';
               miniruta:='NO RUTA';
               recibido:='';
               ruta:=TestDirectorio();
               ListBox1.Items.Add('.............');
               ListBox1.Items.Add(ruta);

               IdUDPServer1.Active:=true;
               IdUDPClientShowrun.Active:=true;
               Timer1.Enabled:=true;
               viaje:=false;

               vuelta:=0;
               TotCarros:=0;
               TotVueltas:=0;
               ViajeActual:=1;
               CarroActual:=0;
               VueltaActual:=1;
               Total:=0;
               m:=0;
               l:=0;
          end;//Del Button1Click -START-


procedure TForm1.Button2Click(Sender: TObject);
            begin
             IdUDPServer1.Active:=false;
             Timer1.Enabled:=false;
             Timer2.Enabled:=false;
             Timer3.Enabled:=false;
             close;
            end;//Del Button2Click -CLOSE-


procedure TForm1.IdUDPServer1UDPRead(Sender: TObject; AData: TStream;
  ABinding: TIdSocketHandle);

       var
             c:Char;
             //recibido:string;
             n:integer;
       begin
             n:=1;
             recibido:='';

              while n <= Adata.Size do
              begin
                  Adata.Read(c,1);
                  recibido:=recibido+c;
                  inc(n);


                  if PARAMETROS = false then
                   begin
                     TestInicial();
                   end;

                  if  PARAMETROS = true then
                   begin
                     //Llegados a este punto ya sabemos los carros y las vueltas
                     //que compone un viaje, asi que deshabilitamos los timer.

                     ProcesoRutina();

                   end;
               end;//del bucle while

end;//del procedimiento IdUDPServer1UDPRead


procedure TForm1.ProcesoRutina();

             begin

               if(recibido ='click') then
                   begin
                        sleep(95);
                        ListBox1.Items.Add('el valor de m es:'+IntToStr(m));
                        if m=1 then Form1.IdUDPClientShowrun.Send('ok');
                        
                        inc(m);
                        if m >  Total then
                           begin
                                MoverFotos();
                                ListBox1.Items.Add('NUEVO VIAJE');
                                inc(ViajeActual);
                                m:=1;
                                CarroActual:=0;
                                VueltaActual:=1;
                        end;
                        inc(CarroActual);

                        if (CarroActual>TotCarros) then
                           begin
                                CarroActual:=1;
                                inc(VueltaActual);

                                if (VueltaActual>TotVueltas) then
                                   begin
                                      VueltaActual:=1;
                                   end;

                                ListBox1.Items.Add('NUEVA VUELTA:'+IntToStr(VueltaActual));
                        end;

                     GestionFoto();

                     
                     if m= Total then
                           begin
                             CopiarFotos();
                             Form1.IdUDPClientShowrun.Send('ko');
                     end;

           end;//DEL IF INICIAL.



end;//del procedimiento ProcesoRutina

procedure TForm1.CopiarFotos();
var
   v:integer;
   Busqueda2: TSearchRec;
begin
   v:= FindFirst('C:\FOTOS\ACTUAL\'+'*.bmp',faAnyFile, Busqueda2);
   while v=0 do
         begin
              CopyFile(Pchar('C:\FOTOS\ACTUAL\'+Busqueda2.Name),Pchar(ruta+Busqueda2.Name),false);
              Application.ProcessMessages;
              v:=FindNext( Busqueda2 );
         end;
   
end;//De CopiarFotos().



procedure TForm1.MoverFotos();
            var
            n:integer;
            Busqueda1: TSearchRec;
            
            begin
                 n:= FindFirst('C:\FOTOS\ACTUAL\'+'*.bmp',faAnyFile, Busqueda1);
                 while n=0 do
                       begin
                          DeleteFile('C:\FOTOS\ACTUAL\'+Busqueda1.Name);
                          //MoveFile(Pchar('C:\FOTOS\ACTUAL\'+Busqueda1.Name),Pchar(ruta+Busqueda1.Name));
                          n:= FindFirst('C:\FOTOS\ACTUAL\'+'*.bmp',faAnyFile, Busqueda1);
                       end;

end;//del procedimiento MoverFotos



procedure TForm1.GestionFoto();
         var
            y:integer;
            Busqueda: TSearchRec;
            s:string;
            B: TBitmap;



          begin

           //Buscamos en el directorio 'C:\PURGATORIO\' la foto creada
           //function FindFirst( const Path: string; Attr: Integer; var F: TSearchRec ): Integer;
            {type
                TSearchRec = record
                Time: Integer;
                Size: Integer;
                Attr: Integer;
                Name: TFileName;
                ExcludeAttr: Integer;
                FindHandle: THandle;
                FindData: TWin32FindData;
                end; }

                y:= FindFirst('C:\FOTOS\PURGATORIO\'+'*.bmp',faAnyFile, Busqueda);
                //ShowMessage( SysErrorMessage(GetLastError()) );
                ListBox1.Update;
                ListBox1.Items.Add('=====================');
                ListBox1.Items.Add('El valor de y es:'+IntToStr(y));

                B:= TBitmap.Create;
                B.LoadFromFile('C:\FOTOS\PURGATORIO\'+Busqueda.name);
                Redimensionar(b,300,200);
                B.SaveToFile(ruta+'MINI\'+'MINI-'+'V'+IntToStr(ViajeActual)+'V'
                +IntToStr(VueltaActual)+'c'+IntToStr(CarroActual)+'.bmp');
                B.Free;
                

                if y=0 then
                   begin

                        ListBox1.Items.Add(Busqueda.Name);
                        if FileExists('C:\FOTOS\PURGATORIO\'+Busqueda.Name)then
                           begin
                                ListBox1.Items.Add('Existe la foto');
                           end;

                        ListBox1.Items.Add('Moviendo...');
                        MoveFile(Pchar('C:\FOTOS\PURGATORIO\'+Busqueda.Name),Pchar('C:\FOTOS\ACTUAL\V'
                        +IntToStr(ViajeActual)+'v'+IntToStr(VueltaActual)+'c'+IntToStr(CarroActual)+'.bmp'));

                        //ShowMessage( SysErrorMessage(GetLastError()) );
                        ListBox1.Update;
                        y:=13;
                   end;


end; //Del procedimiento GestionFoto


procedure TForm1.Redimensionar(Imagen: TGraphic; Ancho, Alto: Integer);
var
   Bitmap: TBitmap;
begin
     Bitmap:= TBitmap.Create;
try
   Bitmap.Width:= Ancho;
   Bitmap.Height:= Alto;
   Bitmap.Canvas.StretchDraw(Bitmap.Canvas.ClipRect,Imagen);
   Imagen.Assign(Bitmap);
   finally
          Bitmap.Free;
end;
end;//De Redimensionar


 

procedure TForm1.TestInicial();

          //var

          begin

               if( (recibido ='click') and (viaje = false) )then
                   begin
                        Timer1.Enabled:=false;//inicializamos el contador
                        Timer1.Enabled:=true;
                        ListBox1.Items.Add(recibido);
                        ListBox1.Update;
               end;//del if

               if( (recibido ='click') and (viaje = true) )then
                   begin//Es porque estoy en el inicio de un viaje
                        Timer2.Enabled:=true;
                        Timer3.Enabled:=false;
                                  inc(carros);

                        if carros=TotCarros then
                           begin
                                carros:=1;
                           end;

                         ListBox1.Items.Add('carro:'+IntToStr(carros));
                         ListBox1.Update;
               end;//del if
end;//End TestInicial



{Cuando vence el Timer1 significa que le siguiente 'click' recibido es el
inicio de un viaje.  15s  }
procedure TForm1.Timer1Timer(Sender: TObject);
          begin
            viaje:=true;
            ListBox1.Items.Add('timer1 vendido');
            ListBox1.Items.Add('Esperando inicio de viaje...');
            Timer1.Enabled:= false;

          end;//Del timer1

{Cuando vence el Timer2 significa que a finalizado un vuelta 5s }
procedure TForm1.Timer2Timer(Sender: TObject);
          begin

             Timer2.Enabled:=false;
             Timer3.Enabled:=true;
             ListBox1.Items.Add('Fin de vuelta');
             inc(vuelta);
          end;//End Timer2Timer


{15s -- Cuando vence el timer3 significa que ha finalizado le viaje}
procedure TForm1.Timer3Timer(Sender: TObject);
          begin
               TotCarros:=carros/vuelta;
               ListBox1.Items.Add('Carros: '+IntToStr(Trunc(TotCarros)));
               ListBox1.Items.Add('vueltas x viaje: '+IntToStr(vuelta));
               TotVueltas:=vuelta;
               ListBox1.Items.Add('Numero total de vueltas: '+IntToStr(TotVueltas));
               ListBox1.Items.Add('Fin de viaje');
               Timer2.Enabled:=false;
               Timer3.Enabled:=false;
               viaje:=false;
               PARAMETROS:=true;
               Total:=Round(TotCarros)*TotVueltas;
               ShellExecute(Form1.Handle,nil,PChar('C:\Users\Paco\Desktop\@BIBLIOTECA DELPHI\Ejemplos Delphi\20110114_Ejemplo_simulador_III\Simulador.exe'),'','',SW_SHOWNORMAL);


          end;//End Timer3Timer


function TForm1.TestDirectorio():string;
   var
   RAIZ:boolean;
   DIRECT:boolean;
   now_B: TDateTime;
   dia:string;
   fecha:string;

   begin
    RAIZ:=false;
   //Buscamos si existe el directorio 'C:\FOTOS'
   //function DirectoryExists( const Directory: string ): Boolean;
   RAIZ:=DirectoryExists( 'C:\FOTOS\' );

   if (RAIZ=false) then
      begin
      //NO xiste el directorio 'C:\FOTOS\'
      ListBox1.Items.Add('No existe el directorio C:\FOTOS\.');
      ListBox1.Update;
      //Creamos el directorio 'C:\FOTOS\'
      ListBox1.Items.Add('Creando directorio raiz y subdirectorios.');
      ListBox1.Update;
      //function CreateDir( const Dir: string ): Boolean;
      RAIZ:=CreateDir( 'C:\FOTOS' );
      CreateDir( 'C:\FOTOS\PURGATORIO');
      CreateDir( 'C:\FOTOS\ACTUAL');
      CreateDir( 'C:\FOTOS\PUBLICIDAD');
      if (RAIZ=false) then
         begin
              ListBox1.Items.Add('No se puede crear el directorio C:\FOTOS\.');
              ListBox1.Update;
      end;//Del if anidado
   end;//Del if

   //Llegados a este punto ya tenemnos creado el directorio 'C:\FOTOS\'
   ListBox1.Items.Add('El directorio raiz C:\FOTOS\ exite');
   ListBox1.Update;

   if (RAIZ=true) then
      begin
      //Comprobamos si existe un directorio actual.
      //El directorio actual es el directorio con la fecha actual
      dia:= DateToStr(Now);
      ListBox1.Items.Add(dia);
      DateSeparator := #0;
      dia:=FormatDateTime('yyyymmdd',now);
      ListBox1.Items.Add(dia);
      ListBox1.Update;
      ListBox1.Items.Add('Comprobamos si existe el directorio del da actual');
      ListBox1.Update;
      DIRECT:=DirectoryExists( 'C:\FOTOS\'+dia+'\' );
      if DIRECT then
          begin
               ListBox1.Items.Add('El directorio del da actual existe');
               ListBox1.Update;
           end
      else
          begin
          ListBox1.Items.Add('Creando directorio C:\FOTOS\'+dia+'\');
          ListBox1.Update;
          DIRECT:=CreateDir( 'C:\FOTOS\'+dia+'\' );
          CreateDir( 'C:\FOTOS\'+dia+'\MINI\' );
      end;//Del if anidado
   end;//Del if
   fecha:='C:\FOTOS\'+dia+'\';
   miniruta:= 'C:\FOTOS\'+dia+'\MINI\';
   Result:=fecha;
   
end;//End TestDirectorio



end.//De la unidad
