unit U_ShowRun;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IdBaseComponent, IdComponent, IdUDPBase,
  IdUDPServer,IdUDPClient,IdSocketHandle, IdTCPServer, IdSMTPServer,XpMan;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Timer1: TTimer;
    ListBox1: TListBox;
    Timer2: TTimer;
    Timer3: TTimer;
    IdUDPServer1: TIdUDPServer;
    procedure FormCreate(Sender: TObject);
    function DirectorioActual():string;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ShowPublicidad();
    procedure ShowHoy();
    procedure ShowActual();
    procedure Timer2Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure IdUDPServer1UDPRead(Sender: TObject; AData: TStream;
      ABinding: TIdSocketHandle);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  hoy:string;
  Cont:integer;

implementation

{$R *.dfm}


procedure TForm1.FormCreate(Sender: TObject);
begin
     form1.ListBox1.clear;
end;// end FormCreate



function TForm1.DirectorioActual():string;
var
   dia:string;
   fecha:string;
begin
     dia:= DateToStr(Now);
     DateSeparator := #0;
     dia:=FormatDateTime('yyyymmdd',now);
     fecha:=('C:\FOTOS\'+dia+'\');
     ListBox1.Items.Add('El directorio del dia de hoy es:'+fecha);
     Result:=fecha;

end;//DE DirectorioActual

(* Buscar los archivos de imgenes almacenar en TStrings *)
function GetArchBMPP(Ruta: string; TS: TStrings):integer;
var
  SR: TSearchRec;
  salida:integer;
begin
   if FindFirst(Ruta+'*.BMP', faAnyFile, SR) = 0 then
   begin
     repeat
      TS.Add(Ruta + SR.Name);
     until FindNext(SR)<> 0;
      FindClose(SR);
      salida:=0;
    end
    else
        begin
        Form1.ListBox1.Items.Add('No hay imagenes que mostrar.');
        salida:=1;
        FindClose(SR);
    end;
    result:=salida;

end;//end GetArchBMP


procedure TForm1.Button1Click(Sender: TObject);
begin

     hoy:= DirectorioActual();
     IdUDPServer1.Active:=true;

     if Button1.Caption = 'START' then
     begin

          Button1.Caption:= 'STOP';

          if DirectoryExists(hoy) then
             begin

              ShowHoy();

          end//end if
          else
              begin

              ShowPublicidad();

          end;//del else 

     end
     else
         begin
          Button1.Caption:= 'START';
          form1.IdUDPServer1.active:=false;
          form1.Timer1.Enabled:=false;
          form1.Timer2.Enabled:=false;
          form1.Timer3.Enabled:=false;

     end;

end;//DEL BOTON START.


procedure TForm1.ShowPublicidad();
const
   RUTA = 'C:\FOTOS\PUBLICIDAD\';
var
   seguir:integer;
  begin
       //form1.ListBox1.clear;
     //ListBox1.Items.Add('El directorio actual es: '+RUTA); // Mostrar ruta
     seguir:=GetArchBMPP(RUTA,ListBox1.Items); // Cargar imgenes
     Cont:= 0;                        // (En posicicin 0 est la el mensaje)

     if seguir=0 then
     begin
     form1.Timer1.Enabled:=true;
     end
     else
      begin
      form1.Timer1.Enabled:=false;
     end;

end;//del ShowPublicidad}


(* OnTimer, mostrar imgen *)
procedure TForm1.Timer1Timer(Sender: TObject);
const
   RUTA = 'C:\FOTOS\PUBLICIDAD\';
begin
  ListBox1.ItemIndex:= Cont;   // Seleccionar imgen a mostrar en ListBox1
  Image1.Picture.LoadFromFile(ListBox1.Items[Cont]); // Mostrar imgen
  if Cont < ListBox1.Items.Count -1 then  // Hay mas imgenes?
    Inc(Cont)    // Siguiente
  else
      //Cont:= 1;    // No, repetir la serie
      GetArchBMPP(RUTA,ListBox1.Items);

end;//del Timer1

procedure TForm1.ShowHoy();
var
  SR: TSearchRec;

begin
      //FindFirst -->Devuelve un cero si ha encontrado algo
      if FindFirst(hoy+'*.BMP', faAnyFile, SR) <> 0 then
        begin

          form1.Timer2.Enabled:=False;
          //ListBox1.Items.Add('ver showpublicidad');
          ShowPublicidad();
        end
     else
         begin
         form1.ListBox1.clear;
          //ListBox1.Items.Add('ver showhoy'); // Mostrar ruta
          GetArchBMPP(hoy,ListBox1.Items); // Cargar imgenes
          Cont:= 1;                  // (En posicicin 0 est la el mensaje)
          form1.Timer2.Enabled:=true;
     end;

end;//del ShowHoy



procedure TForm1.Timer2Timer(Sender: TObject);
begin
  ListBox1.ItemIndex:= Cont;   // Seleccionar imgen a mostrar en ListBox1
  Image1.Picture.LoadFromFile(ListBox1.Items[Cont]); // Mostrar imgen
  if Cont < ListBox1.Items.Count -1 then  // Hay mas imgenes?
    Inc(Cont)    // Siguiente
  else
      //Cont:= 1;    // No, repetir la serie
      GetArchBMPP(hoy,ListBox1.Items);

end;//del Timer2


procedure TForm1.ShowActual();
const
   RUTA = 'C:\FOTOS\ACTUAL\';
  begin
       form1.ListBox1.clear;
     //ListBox1.Items.Add('El directorio actual es: '+RUTA); // Mostrar ruta
     GetArchBMPP(RUTA,ListBox1.Items); // Cargar imgenes
     Cont:= 0;                        // (En posicicin 0 est la el mensaje)
     form1.Timer3.Enabled:=true;
end;//del ShowActual


procedure TForm1.Timer3Timer(Sender: TObject);
const
   RUTA = 'C:\FOTOS\ACTUAL\';
begin
  ListBox1.ItemIndex:= Cont;   // Seleccionar imgen a mostrar en ListBox1
  Image1.Picture.LoadFromFile(ListBox1.Items[Cont]); // Mostrar imgen
  if Cont < ListBox1.Items.Count -1 then  // Hay mas imgenes?
    Inc(Cont)    // Siguiente
  else
      //Cont:= 1;    // No, repetir la serie
      GetArchBMPP(RUTA,ListBox1.Items);

end;//del Timer3

procedure TForm1.IdUDPServer1UDPRead(Sender: TObject; AData: TStream;
  ABinding: TIdSocketHandle);
var
        c:Char;
        recibido:string;
        n:integer;

     begin
          recibido:='';
          n:=1;

          while n <= Adata.Size do
                begin
                     Adata.Read(c,1);
                     recibido:=recibido+c;
                     inc(n);
                end;

          if recibido ='ok' then
          begin

               form1.Timer1.Enabled:=false;
               form1.Timer2.Enabled:=false;
               form1.Timer3.Enabled:=false;
                ShowActual();

          end;

          if recibido = 'ko' then
          begin
               sleep(1000);
               form1.Timer1.Enabled:=false;
               form1.Timer2.Enabled:=false;
               form1.Timer3.Enabled:=false;
               ShowHoy();
          end;

end;//del IdUDPServer

end.
