unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdUDPServer, IdBaseComponent, IdComponent, IdUDPBase,
  IdUDPClient, IdSocketHandle, ExtCtrls, IdTCPServer, IdSMTPServer,XpMan;

type
  TForm1 = class(TForm)
    IdUDPServerSensor: TIdUDPServer;
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    ListBox1: TListBox;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure IdUDPServerSensorUDPRead(Sender: TObject; AData: TStream;
      ABinding: TIdSocketHandle);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  x:integer;
  ruta:string;
  
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);//Boton Start/Stop
begin

if Button1.Caption = 'Start' then
    begin
         Button1.Caption:='Stop';
         IdUDPServerSensor.Active:= true;
         //IdUDPServerMontador.Active:=true;
         Listbox1.Clear;
         ListBox1.Items.Add('Inicio');
         x:=1;
    end
else
    begin
         Button1.Caption:='Start';
         IdUDPServerSensor.Active:= False;
     end;

end;//end botn start


procedure TForm1.Button2Click(Sender: TObject);//Boton Close
begin
     IdUDPServerSensor.Active:= false;
     //IdUDPServerMontador.Active:=false;
     close;
end;//end boton close


procedure TForm1.Button3Click(Sender: TObject);//Boton Reset
begin
       listbox1.Clear;
       x:=1;
       ListBox1.Items.Add('Reiniciando aplicacion.');
       ListBox1.Items.Add('Contador reseteado');
end;//Botn Reser


procedure TForm1.IdUDPServerSensorUDPRead(Sender: TObject; AData: TStream;
  ABinding: TIdSocketHandle);

///Y si recibe otro 'click' antes de que termine de leer el anterior?

var
   c:Char;
   recibido:string;
   n:integer;
   b: TBitMap;

begin
     ruta:='C:\FOTOS\PURGATORIO\';
     recibido:='';
     n:=1;
     

     while n <= Adata.Size do
     begin
           Adata.Read(c,1);
           recibido:=recibido+c;
           inc(n);
           //ListBox1.Items.Add(recibido);
           //ListBox1.Update;
     end;

     if recibido ='click' then
     begin
       //ListBox1.Items.Add('5555555555'+recibido);
       //ListBox1.Items.Add( 'De: ' + ABinding.PeerIP );
       //ListBox1.Items.Add( 'Mensaje: ' + PChar( AData ) );
       //ListBox1.Update;
       //ListBox1.Items.Add(ruta);
       b:= TBitmap.Create;
       b.Width:= 450;
       b.Height:= 300;
       b.Canvas.TextOut(100,150,'FOTO'+IntToStr(x));
       b.SaveToFile(ruta+IntToStr(x)+'.bmp');
       ListBox1.Items.Add(ruta+IntToStr(x)+'.bmp');
       Image1.Picture.Assign(b);
       b.Free;

       Inc(x);
    end;

end;//Del primer server que recibe el 'click'.

{
procedure TForm1.IdUDPServerMontadorUDPRead(Sender: TObject; AData: TStream;
  ABinding: TIdSocketHandle);
   //La ruta que recibiremos por parte del MONTADOR es de 18 carcteres.
   //A travs de estos 18 caracteres lo controlaremos.

  var
   d:Char;
   m:integer;

  begin
     ruta:='';
     m:=1;

     while m <= Adata.Size do
     begin
           Adata.Read(d,1);
           ruta:=ruta+d;
           inc(m);
           ListBox1.Items.Add(ruta);
           //ListBox1.Update;
           ListBox1.Items.Add(IntToStr(m));
           //if m=18 then exit;
     end;//Del while

     if m = 19 then
        begin
          ListBox1.Items.Add(ruta);
          ListBox1.Items.Add('servidor del click activado');
          //IdUDPServerMontador.Active:=false;

          IdUDPServerSensor.Active:=true;
      end;


end;//Del segundo server que recibe la ruta donde pooner las fotos.
}

procedure TForm1.FormCreate(Sender: TObject);
begin
         Button1.Caption:='Stop';
         IdUDPServerSensor.Active:= true;
         //IdUDPServerMontador.Active:=true;
         Listbox1.Clear;
         ListBox1.Items.Add('Inicio');
         x:=1;
end;

end.



